 /**
 *  Created by Gifer on 26.05.2016.
 */

 const net     = require('net');
 const Service = require('./service');
 const console = require('gifer-console');

 console.DublicateToFile('../logs/' + Service.formatDate(new Date(), 'yyyy/mm/dd') + '/nodewebkit.log');

 let mcconnect = function (config, cmdParsing, disconnectCB){
     let CRLF        = "\r\n";
     let inBuffer    = [];
     let localServer = null;

     function ProcessingReceivedData (buffer) {
         let data = buffer;

         if (data !== ''){
             let idx      = data.indexOf("=");
             let CMD_numb = data.slice(0, idx === -1 ? data.length : idx);
             let Data     = data.slice(idx + 1, data.length);

             console.log('Receive CMD: ' + CMD_numb);
             console.log('Receive DATA: ' + Data);

             cmdParsing(CMD_numb, Data);
         } else {
             console.warn("Processing Received - DATA is empty");
         }
     }

     localServer  = net.connect({
         port: config.port,
         host: '127.0.0.1'
     });

     localServer.on('data', (data) => {
         inBuffer += data.toString();

         let idx = inBuffer.indexOf(CRLF);

         while (idx !== -1) {
             ProcessingReceivedData(inBuffer.slice(0, idx));

             inBuffer = inBuffer.slice(idx + 2, inBuffer.length);

             idx = inBuffer.indexOf(CRLF);
         }
     });

     localServer.on('connect', () => {
         console.log('Connected to MyChat Client');

         localServer.write(Service.convertToEntities("ready" + CRLF));
     });

     localServer.on('end', () => {
         console.important('\"End\" connections to MyChat Client');

         process.nextTick(() => disconnectCB());
     });

     localServer.on('error', (err) => {
         disconnectCB(((err) ? err.syscall : "unknown error") + " host: [127.0.0.1:" + config.port + "]\n Closing plugin, full error text: " + JSON.stringify(err), 1);
     });

     localServer.on('timeout', (err) => {
         console.log('Timeout occurred!');

         disconnectCB(((err) ? err.syscall : "unknown error") + " host: [127.0.0.1:" + config.port + "]\n Closing plugin, full error text: " + JSON.stringify(err), 1);
     });

     return {
         SendDataToServer: (_data) => {
             console.log('Sending Data To Server: ' + _data);

             if (localServer) {
                 localServer.write(Service.convertToEntities(_data + CRLF));
             }
         }
     };
 };

 module.exports = mcconnect;